#include "../std.h"
#include "../config/config_map.h"
#include "../transfer/replica_utils.h"
#include "../transfer/replica.h"
#include "../misc/url_options.h"
#include "../misc/checksum.h"
#include "../misc/log_time.h"

#include "datapoint.h"

bool DataPoint::meta_resolve_se(bool source) {
  is_resolved=true;
  return true;
}

bool DataPoint::meta_preregister_se(bool replication,bool force) {
  return true;
}

bool DataPoint::meta_postregister_se(bool replication,bool failure) {
  return true;
}

bool DataPoint::meta_preunregister_se(bool replication) {
  return true;
}

bool DataPoint::meta_unregister_se(bool all) {
  return true;
}

bool DataPoint::process_meta_url_se(const string &url,string &cat_url,string &filename,list<DataPoint::Location> &locations) {
  if(!strncasecmp(url.c_str(),"se://",5)) {
    int n = url.find('?',5);
    if(n == string::npos) return false;
    locations.clear();
    filename=url.c_str()+n+1;
    cat_url=url; cat_url.resize(n);
    string url_("httpg://"); url_+=cat_url.c_str()+5;
cerr<<"process_meta_url_se: location: "<<cat_url.c_str()+5<<endl;
cerr<<"process_meta_url_se: location url: "<<url_<<endl;
    locations.push_back(
      DataPoint::Location(cat_url.c_str()+5,url_.c_str())
    );
    is_resolved=true; // resolving is not needed
cerr<<"process_meta_url_se: url: "<<url<<endl;
cerr<<"process_meta_url_se: catalog: "<<cat_url<<endl;
cerr<<"process_meta_url_se: lfn: "<<filename<<endl;
    return true;
  };
  return false;
};

bool DataPoint::list_files_se(list<DataPoint::FileInfo> &files,bool resolve) {
  odlog(0)<<"List lfns in SE: not implemented"<<endl;
  return false;
};

