/*********************************************************************
 *
 * Authors: Vincenzo Ciaschini - Vincenzo.Ciaschini@cnaf.infn.it 
 *
 * Copyright (c) 2002, 2003 INFN-CNAF on behalf of the EU DataGrid.
 * For license conditions see LICENSE file or
 * http://www.edg.org/license.html
 *
 * Parts of this code may be based upon or even include verbatim pieces,
 * originally written by other people, in which case the original header
 * follows.
 *
 *********************************************************************/
#ifndef ___FORMAT_H
#define ___FORMAT_H

#include <string>
#include <openssl/pem.h>

/* format.c */
struct collection {
  string user;
  string userca;
  string server;
  string serverca;
  string voname;
  string date1;
  string date2;
  int    datalen;
  string data;
  string uri;
};

extern bool unformat(const string data, const EVP_PKEY *key,
		     collection &results);
extern bool format(const string data, const string user, const string userca,
		   const string server, const string serverca,
		   const EVP_PKEY *key, int valid, const string voname, 
		   const string uri, string &formatted);
#endif
