#include "httpsd.h"
#include "server/service_soap.h"

#ifndef __SE_INTERNAL_INCLUDE__
#include "se/file_soap.h"
#endif

#define SUCCESS                   0
#define ERR_MISSING_INPUT_DATA    1
#define ERR_EXCESSIVE_INPUT_DATA  2
#define ERR_WRONG_INPUT_DATA      3
#define ERR_OBJECT_MISSING        4
#define ERR_INSUFFICIENT_ACCESS   5
#define ERR_CREATING_NEW_FILE     10
#define ERR_UPDATING_FILE         11
#define ERR_INTERNAL_ERROR        100


class HTTP_SE_Handle;

class SEFile;
class SEFiles;
class SEAttributes;

class HTTP_SE: public HTTP_ServiceAdv {
  friend int ns__add(struct soap* sp,ns__fileinfo *file, struct ns__addResponse &r);
  friend int ns__info(soap *sp, char *pattern, ns__infoResponse &r);
  friend int ns__acl(soap *sp, char *acl, ns__aclResponse &r);
  friend int ns__del(soap *sp, ns__delResponse &r);
  friend int ns__update(struct soap *sp, ns__fileinfo *file, struct ns__updateResponse &r);
 private:
  HTTP_SE_Handle* handle;
  string url;
  const char* current_name;
  SEFile* current_file;
 public:
  HTTP_SE(HTTPS_Connector *c,HTTP_SE_Handle *handle,const char* uri);
  virtual ~HTTP_SE(void);
  virtual HTTP_Error get(const char* uri,int &keep_alive);
  virtual HTTP_Error put(const char* uri,int &keep_alive);
  virtual HTTP_Error post(const char* uri,int &keep_alive);
  virtual void soap_methods(void);
  SEFile* new_file(SEAttributes& attr);
  SEFiles* files(void);
};

HTTP_Service* se_service_creator(HTTPS_Connector& c,const char* uri,void* arg);
bool se_service_configurator(istream& f,const char* uri,HTTP_Service_Properties &prop);
